#include "includes.h"

int debug = 1;

int main(int argc, char **argv)
{
  int sockfd,
      newsockfd,
      clilen,
      childpid,
      loopcount;

  struct sockaddr_in cli_addr, 
                     serv_addr;

  pname = argv[0];

  catch_signals();

  if((sockfd = socket(PF_INET, SOCK_STREAM, 0)) < 0)
  {
    perror("Server : Can't open stream socket ");
    return(2);
  }

  DB printf("Created socket.\n");

  bzero((char *) &serv_addr, sizeof(serv_addr));
  
  serv_addr.sin_family		= AF_INET;
  serv_addr.sin_addr.s_addr	= htonl(INADDR_ANY);
  serv_addr.sin_port		= htons(SERV_TCP_PORT);

  setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, (struct sockaddr *) &serv_addr, sizeof(serv_addr));

  DB printf("Set socket options.\n");

  if(bind(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0)
  {
    perror("Server : can't bind local address ");
    return(2);
  }
 
  DB printf("Bound socket, port : %d.\n", SERV_TCP_PORT);

  DB printf("lisiting...\n");
  listen(sockfd, 5);

  for( loopcount = 1; ; loopcount++ )
  {
    clilen = sizeof(cli_addr);
    DB printf("Waiting for connection %d...\n", loopcount);
    newsockfd = accept(sockfd, (struct sockaddr *) &cli_addr, &clilen);

    if(newsockfd < 0)
    {
      if(errno == EINTR)
        continue;
      else 
      {
        perror("Server : accpet error ");
        return(2);
      }
    }

    DB printf("accepted connection : %d\n", loopcount); /**/

    if(newsockfd < 0)
    {
      perror("Server : accept error ");
      return(2);
    }
    
    DB printf("Got connection %d, forking child...\n", loopcount);
  
    if((childpid = fork()) < 0) /* do fork */
    {
      perror("Server : fork error ");
      return(-1);
    }
    else if(childpid == 0)
    {
      DB printf("Forked into child pid : %d.\n", childpid);
      DB printf("Closing parent's connection, %d.\n", childpid);
      close(sockfd);
      DB printf("calling str_echo, pid %d\n", childpid);
      str_echo(newsockfd);
      DB printf("Done with echo, pid : %d.\n", childpid);
      exit(0);
    }
    printf("starting child %d.  loopcount : %d\n", childpid, loopcount);
    close(newsockfd);
  }
}
