/** str.c **/
/** My secure replacements to the standard Clib.  No overflows, and 200% faster
**/

#include "includes.h"

/* Identical to strcmp, but secure, and MUCH faster. */

int str_diff(s,t)

  register char *s;
  register char *t;

{
  register char x;

 for(;;)
  {
   x = *s;

   if(x != *t) 
     break;
  
   if(!x)
     break;
  
   ++s;
   ++t;
 
   x = *s;
 
   if(x != *t)
     break;
  
   if(!x)
     break;
   
   ++s;
   ++t;
  
   x = *s;
   
   if(x != *t)
      break;

   if(!x)
     break;
 
   ++s;
   ++t;
 
   x = *s;
   
   if(x != *t)
     break;
 
   if(!x)
     break;
  
   ++s;
   ++t;
  }
 
return((int)(unsigned int)(unsigned char) x)
                                      - ((int)(unsigned int)(unsigned char) *t);
}

/* Just like strlen. */

unsigned int str_len(s)

  register char *s;

{ 
  register char *t;

  t = s;
  for(;;)
    {
      if(!*t)
        return t - s;
    
      ++t;
  
      if(!*t)
        return t - s;
      
      ++t;

      if(!*t)
        return t - s;
     
      ++t;
   
      if(!*t)
        return t - s;
    
      ++t;
    }
}

/* Just like strcpy, but better. */

unsigned int str_copy(s,t)
  
  register char *s;
  register char *t;

{
 
  register int len;

  len = 0;
  for (;;)
   {
     if(!(*s = *t))
       return len;

      ++s;
      ++t;
      ++len;

      if(!(*s = *t))
        return len;

      ++s;
      ++t;
      ++len;
    
      if(!(*s = *t))
        return len;

      ++s;
      ++t;
      ++len;
    
      if(!(*s = *t))
        return len;
   
      ++s;
      ++t;
      ++len;
   }
}
/* Convert string to all uppercase
 * Accepts: string pointer
 * Returns: string pointer
 */

char *ucase (char *s)
{
  char c;
  char *string = s;
                                /* if lowercase covert to upper */
  for(; c = *s; s++)
    if(islower (c))
      *s -= 'a'-'A';

  return (string);                      /* return string */
}

/* Convert string to all lowercase
 * Accepts: string pointer
 * Returns: string pointer
 */

char *lcase (char *s)
{
  char c;
  char *string = s;
                                /* if uppercase covert to lower */
  for(; c = *s; s++)
    if(isupper (c))
      *s += 'a'-'A';

  return (string);                      /* return string */  
}

int *chop(char *s)
{
  int slen;
  
  slen = str_len(s);
  s[slen - 1] = '\0';
  
  return((int *) slen);
}

