#include "includes.h"

void str_cli(FILE *fp, int sockfd)
{
  extern int debug;
  int n, maxfdp1;
  fd_set readfd;
  char sendline[MAXLINE], recvline[MAXLINE + 1];

  FD_ZERO(&readfd);
  
  for( ; ; )
  {
    FD_SET(fileno(fp), &readfd);
    FD_SET(sockfd, &readfd);
    maxfdp1 = max(fileno(fp), sockfd) + 1;
   
    DB printf("maxfdp1 : %d\n", maxfdp1);
     
    if(select(maxfdp1, &readfd, NULL, NULL, NULL) <= 0)
    {
      perror("str_cli - select error ");
      return;
    }

    if(FD_ISSET(sockfd, &readfd))
    {
      n = readline(sockfd, recvline, MAXLINE);
      if(n < 0)
      {
        perror("str_cli - readline error ");
        return;
      }
      else if(n == 0)
      {
        printf("Server terminated connection\n");
        return;
      }
      
      recvline[n] = 0;
      fputs(recvline, stdout);
    }

    if(FD_ISSET(fileno(fp), &readfd))
    {
      if(fgets(sendline, MAXLINE, fp) == NULL)
      {
        if(ferror(fp))
        {
          perror("str_cli - error reading stdin ");
          return;
        }
      }

      n = strlen(sendline);
      if(writen(sockfd, sendline, n) != n)
      {
        perror("str_cli - writen error on socket ");
        return;
      }
    }
  }
}

void str_echo(int sockfd)
{
  extern int debug;
  int n,
      times,
      count;
  char line[MAXLINE], cmdline[MAXLINE], output[MAXLINE];
  FILE *output_fp;

  DB printf("Into str_echo.\n"); 

  for( times = 0; ; times++)
  {
    DB printf("times looped : %d\n", times); 

    DB printf("Calling readline...\n"); 
    n = readline(sockfd, line, MAXLINE);
    DB printf("Back from readline into str_echo, n is %d\n", n); 

    if(n == 0)
    {
      DB printf("returning out of str_echo 1\n"); 
      return;
    }
    else if(n < 0)
    {
      perror("server - str_echo : readline error 1 ");
      return;
    }
    
    strncpy(cmdline, line, MAXLINE); 
    
    chop(cmdline);

    DB printf("got : %s.\n", cmdline);

    if(!strcmp("quit", cmdline))
    {
      printf("Time to quit\n");
      return;
    }

    if(!strcmp("uptime", cmdline))
    {
      output_fp = popen("/usr/bin/uptime", "r");
      fgets(output, MAXLINE, output_fp); 
      count = strlen(output);
      printf("%d, %s", count, output);
      pclose(output_fp);
      
      strcat(line, output);
      n += count;
    }

    DB printf("Over here ... calling writen.\n"); 

    if(writen(sockfd, line, n) != n)
    {
      perror("Server - str_echo : writen error ");
      return;
    } 

   DB printf("Ok, done with writen.\n"); 
  }
}

ssize_t readline(int fd, void *vptr, int maxlen)
{
  size_t n;
  ssize_t rc;
  static char *ptr, c;

  ptr = vptr;

  for(n = 1; n < maxlen; n++)
  {
    if((rc = read(fd, &c, 1)) == 1)
    {
      *ptr++ = c;

      if(c == '\n')
      {
        break;
      }
    }
    else if(rc == 0)
    {
      if(n == 1)
      {
        return(0);
      }
      else 
        break;
    }
    else 
    {
      return(-1);
    }
  }
  *ptr = 0;
  return(n);
}  

ssize_t writen(int fd, const void *vptr, size_t n)
{
  size_t nleft;
  ssize_t nwritten;
  const char *ptr;

  ptr = vptr;
  
  nleft = n;
 
  while(nleft > 0)
  {
    if((nwritten = write(fd, ptr, nleft)) <= 0)
      return(nwritten); /* error */
  
    nleft -= nwritten;
    ptr += nwritten;
  }

  return(n - nleft);
}

